//
//  STAppDelegate.m
//  Safe Terminal
//
//  Created by Nir on 22/02/06.
//  Copyright 2006 Nir Soffer. All rights reserved.
//

#import "STAppDelegate.h"


@implementation STAppDelegate

- (id)init;
{
    /* Check if we should install and observe
    applicationDidFinishLounching in which we will try to install the
    delegate */
    
    if ((self = [super init])) {
        if (! [self install]) {
            [self dealloc];
            return nil;            
        }
    }
    return self;    
}

- (BOOL)install;
{    
    /* Install self as Terminal.app application delegate, and the
    original delegate as my delegate. This allow easy overiding of the
    needed methods on the original delegate. */

    NSString *bundleIdentifier = [[NSBundle mainBundle] bundleIdentifier];
    if (! [bundleIdentifier isEqualToString:@"com.apple.Terminal"])
        return NO;

    id applicationDelegate = [NSApp delegate];
    if (applicationDelegate == nil) {
        NSLog(@"error: no application delegate?! quiting.");
        return NO;
    }
    
    [self setDelegate:applicationDelegate];
    [NSApp setDelegate:self];
    NSLog(@"Terminal.app has been secured.");
    return YES;
}

- (void)setDelegate:(id)anObject;
{
    /* By convention Cocoa objects do not retain their delegates. See
    http://developer.apple.com/documentation/Cocoa/Conceptual/CommunicateWithObjects/index.html */
    
    delegate = anObject;
}

/* Delegate implementaion */

- (void)forwardInvocation:(NSInvocation *)invocation
{
    /* Forward anything I don't implement to the delegate */
    
    SEL aSelector = [invocation selector];
    
    if ([delegate respondsToSelector:aSelector])
        [invocation invokeWithTarget:delegate];
    else
        [self doesNotRecognizeSelector:aSelector];
}

- (NSMethodSignature *)methodSignatureForSelector:(SEL)aSelector
{
    /* Rquired to implement a delegate */
    
    return [delegate methodSignatureForSelector:aSelector];
}

- (BOOL)application:(NSApplication *)theApplication openFile:(NSString *)filename
{
    /* Preventing excution of files */
    
    NSLog(@"will not execute %@.", filename);
    NSBeep();
    return NO;
}


@end
